#ifndef LCA_H
#define LCA_H

/**
 * A generic node data type...
 */
typedef struct node_t
{
  struct node_t *left;
  struct node_t *right;
  unsigned int value;
} node_t;

/**
 * Structure to hold the LCA pre-precessed data
 */
typedef struct lca_t
{
  node_t **E;            /* An euler tour of the tree                */
  unsigned int *R;       /* Representative of each index in the tour */
  struct pm_rmq_t *rmq;  /* <O(n), O(1)> Range-Minimum-Query structure */
} lca_t;

lca_t  *lca_init( node_t *root, unsigned int n );
node_t *lca_query( lca_t *lca, unsigned int u, unsigned int v );

node_t *build_cartesian_tree( unsigned int *a, unsigned int n );
#endif
